#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define N 20000
short int dp[N][N];

int findLongest(vector<pair<int, int> >a, int n, int present, int previous){
    if (present == n) {
        return 0;
    }
    else if (previous != -1) {
        if (dp[present+1][previous] != -1)
            return dp[present+1][previous+1];
    }
    int ans = 0;
    if (previous == -1) {
        ans = 1 + findLongest(a, n, present + 1, present);
        ans = max(ans, findLongest(a, n, present + 1, previous));
    }
    else {
        int h1 = a[previous].first;
        int h2 = a[present].first;
        int w1 = a[previous].second;
        int w2 = a[present].second;
        if ((h1 <= h2 && w1 <= w2)) {
            ans = max(ans, findLongest(a, n, present + 1, previous));
        }
        else {
            ans = 1 + findLongest(a, n, present + 1, present);
            ans = max(ans, findLongest(a, n, present + 1, previous));
        }
    }
    return dp[present+1][previous+1] = ans;
}

int getLongest(vector<pair<int,int > >& a, int n)
{

    for(int i = 0;i<=n;i++) for(int z = 0;z<=n;z++) dp[i][z] = -1;
    sort(a.begin(),a.end());
    int ans = findLongest(a, n, 0, -1);
    cout << ans;
    exit(0);
}

int main()
{
    vector<pair<int,int> >v;
    int n;
    cin >> n;
    v.resize(n);
    for(int i = 0;i<n;i++) cin >> v[i].first >> v[i].second;
    cout << getLongest(v,n) << endl;
}
