#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;
using ll = long long;
using ld = long double;
using pi = pair<ll, ll>;
using vi = vector<ll>;
using vpi = vector<pi>;
using vvi = vector<vi>;
using vvpi = vector<vpi>;
using ordered_set = tree<pi, null_type, less<pi>, rb_tree_tag, tree_order_statistics_node_update>;
 
ld PI = 3.141592653589793;
ld EPS = 1e-10;
 
ll MOD = 1e9 + 7;
 
 
/////////////////////// BEGIN SOLUTION /////////////////////////////
 
  
ll get_rand(ll l, ll r) {
    ll first_rand_value = (rand() * rand()) % MOD + MOD;
    ll second_rand_value = (rand() * rand()) % MOD + MOD;
    return (first_rand_value * second_rand_value) % (r - l + 1) + l;
}
 
ll mass[(int)3e5];
void solution() {
    
    ll n;
    cin >> n;
    for (ll i = 0; i < n; i++) {
        cin >> mass[i];
    }
    vpi new_mass(1, {mass[0], 1});
    for (ll i = 1; i < n; i++) {
        if (new_mass.back().first == mass[i]) {
            new_mass.back().second++;
        } else {
            new_mass.push_back({mass[i], 1});
        }
    }
    ll max_ans = 0;
    
    for (ll i = 0; i < new_mass.size(); i++) {
        
        ll cur_ind = i;
        ll cur_ans = new_mass[i].second;
        // cout << i << " - "; 
        while (cur_ind < new_mass.size()) {
            // cout << cur_ind << "  ";
            pi looking_pair = {new_mass[cur_ind].first + new_mass[cur_ind].first - new_mass[i].first,  0};
            ll n_ind = lower_bound(new_mass.begin(), new_mass.end(), looking_pair) - new_mass.begin();
            cur_ind = max(n_ind, cur_ind + 1);
            if (cur_ind == new_mass.size()) break;
            cur_ans++;
        }
        // cout << endl;
        max_ans = max(max_ans, cur_ans);
    }


    cout << n - max_ans << endl;
}
 
///////////////////////// END SOLUTION //////////////////////////////
 
 
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    srand(time(0));
    ll t;
    cin >> t;
    // t = 1;
    while (t--){
        solution();
    }    
    return 0;
}