#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define MAXL 30005
#define lsone(x) x&(-x)
typedef pair<int,int> pii;

int bit[MAXL];
vector<pii> rect;
int N,ans;

void update(int pos,int val){
    for(int v=pos;v<=MAXL;v+=lsone(v)){
        bit[v]=max(bit[v],val);
    }
}

int query(int pos){
    int ans=0;
    for(int v=pos;v>0;v-=lsone(v)){
        ans=max(ans,bit[v]);
    }
    return ans;
}

int main(){
    scanf("%d",&N);
    for(int i=0;i<N;i++){
        int x,y;
        scanf("%d%d",&x,&y);
        rect.push_back({x,y});
    }
    sort(rect.begin(),rect.end(),greater<pii>());
    for(auto p:rect){
        int y=p.second;
        int dp=query(y-1)+1;
        ans=max(ans,dp);
        update(y,dp);
    }
    printf("%d",ans);
}