#include <iostream>
#include "guess.h"

#ifdef LOCAL
#include "Lgrader.cpp"
#endif // LOCAL

using namespace std;

int64_t guess_helper(int64_t l, int64_t r) {
    if(l == r) return l;
    int64_t mid = (l + r) / 2;
    switch(quest(mid)) {
    case 0:
        return mid;
    case 2:
        return guess_helper(l, mid - 1);
    case 1:
        return guess_helper(mid + 1, r);
    }
}

void guess(void) {
    clock_t start() = clock();

    int64_t secret = guess_helper(1, 1e18);

    int64_t ret = secret % 8;

    int some_var = 0;
    while((1.0 * clock() - start) / CLOCKS_PER_SEC < (0.01) * ret) some_var++;

    res(secret);
}

#ifdef LOCAL

int main()
{
    cin >> N;
    guess();
}

#endif // LOCAL
