#include <bits/stdc++.h>

using namespace std;
#define int long long

struct fenwick {
    vector<int> a;

    fenwick(int n) {
        a.resize(n, -1e18);
    }

    void add(int x, int val) {
        while (x <= a.size() - 1) {
            a[x] = max(a[x], val);
            x = x | (x + 1);
        }
    }

    int get(int x) {
        int ans = -1e18;
        while (x != -1) {
            ans = max(ans, a[x]);
            x = x & (x + 1);
            --x;
        }
        return ans;
    }
};

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    sort(a.rbegin(), a.rend());
    int dp[n];
    dp[0] = 1;
    fenwick fw = fenwick(30001);
    fw.add(a[0].second, dp[0]);
    for (int j = 1; j < n; ++j) {
        dp[j] = max(1ll, fw.get(a[j].second - 1) + 1);
        fw.add(a[j].second, dp[j]);
    }
    int ans = -1e18;
    for (int k = 0; k < n; ++k) {
        ans = max(ans, dp[k]);
    }
    cout << ans;
}