#include <set>
#include <iostream>
#include <deque>

using namespace std;

void solve()
{
    int n, x, y;
    cin >> n;
    multiset<pair<int, int>> a;
    for (int i = 0; i < n; i++) {
        cin >> x >> y;
        a.emplace(x, y);
    }
    deque<pair<int, int>> q;
    for (auto& i : a) {
        if (q.empty()) {
            q.emplace_back(i.second, i.first);
        }
        if (i.second < q.back().first) {
            q.emplace_back(i.second, i.first);
        }
        else if (i.second == q.back().first) {
            if (q.back().second < i.first) {
                q.emplace_back(i.second, i.first);
            }
        }
        else {
            auto j = lower_bound(q.begin(), q.end(), make_pair(i.second, 0));
            if (j == q.end()) {
                q.pop_front();
                q.emplace_front(i.second, i.first);
            }
            
        }
    }
    cout << q.size();
}

int main()
{
    solve();
    return 0;
}