﻿// P1_largest.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<pii, int> piii;
typedef vector<piii> vp;
typedef vector<int> vi;
typedef vector<int> vvi;

/*struct cmpr {
    bool operator()(const piii& a, const piii& b) {
        return (a.first.first < b.first.first) || (a.first.first == b.first.first && a.first.second > b.first.second);
    }
};*/

bool cmpr(const piii& a, const piii& b) {
    return (a.first.first < b.first.first) || (a.first.first == b.first.first && a.first.second > b.first.second);
}

int main() {
    int n; cin >> n;
    vp r(n);
    vi sec(n);
    for (int i = 0; i < n; i++) {
        int a, b; cin >> a >> b;
        r[i] = { {a, b }, i };
        sec[i] = b;

    }
    sort(r.begin(), r.end(), cmpr);
    vi dp(n, 1);
    for (int i = n - 2; i >= 0; i--) {
        int cur_max = 0;
        for (int j = i + 1; j < n; j++) {
            int ai = r[i].first.first, aj = r[j].first.first, ind = r[i].second;
            if (sec[r[j].second] < sec[ind] && ai != aj)
                cur_max = max(cur_max, dp[j]);
        }
        dp[i] += cur_max;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        ans = max(ans, dp[i]);
    }
    cout << ans << endl;
    return 0;
}
