#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define fr first
#define sc second
#define mp make_pair
#define pb push_back

int main(){
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<vector<int>> side(30002);
    vector<pair<int, int>> rect(n);
    for(int i = 0; i < n; ++i){
        int x, y;
        cin >> x >> y;
        rect[i] = mp(x, y);
        side[x].pb(i);
        side[y].pb(i);
    }

    vector<int> p(300002, 0); p[0] = 0;
    vector<bool> used(n, 0);
    for(int i = 1; i <= 30001; ++i){
        p[i] = p[i - 1];
        for(auto j: side[i]){
            if(used[j]){
                used[j] = 0;
                --p[i];
            }
            else{
                used[j] = 1;
                ++p[i];
            }
        }
    }

    int ans = 0;
    for(int i = 0; i < n; ++i){
        int x = rect[i].fr;
        int y = rect[i].sc;
        if(x > y) swap(x, y);
        ans = max(ans, p[x] - p[y + 1]);
    }

    cout << ans << '\n';

    return 0;
}
