#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  ll n;
  cin >> n;
  vector<ii> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i].first >> a[i].second;
  }
  sort(a.begin(), a.end());
  reverse(a.begin(), a.end());

  vector<vi> dp(n, vi(20'000));
  dp[0][a[0].second] = 1;
  for (int i = 1; i < dp.size(); ++i) {
    for (int j = 0; j < dp[i].size(); ++j) {
      if (a[i].second != j) {
        dp[i][j] = dp[i - 1][j];
      } else {
        ll best = 0;
        for (int k = 0; k < j; ++k) {
          best = max(best, dp[i - 1][k]);
        }
        dp[i][j] = best + 1;
      }
    }
  }
  ll ans = 0;
  for (auto e: dp[n - 1]) {
    ans = max(ans, e);
  }
  cout << ans << endl;
}
