#include <cstdio>
#include <utility>
#include <algorithm>

const int N = 20005;
const int X = 30005;
int n, d[N];
std::pair<int, int> a[N];
int t[X << 1];

void upd(int i, int x)
{
    for (i += X, t[i] = std::max(t[i], x); i > 1; i >>= 1) t[i >> 1] = std::max(t[i], t[i ^ 1]);
}

int get(int l, int r)
{
    int res = 0;
    for (l += X, r += X; l < r; l >>= 1, r >>= 1) {
        if (l & 1) res = std::max(res, t[l++]);
        if (r & 1) res = std::max(res, t[--r]);
    }
    return res;
}

int main()
{
    scanf("%d", &n);
    for (int i = 0; i < n; ++i) scanf("%d%d", &a[i].first, &a[i].second);
    std::sort(a, a + n);
    int ans = 0;
    for (int i = 0; i < n;) {
        int j = i;
        do {
            d[i] = get(a[i].second + 1, X) + 1;
            ans = std::max(ans, d[i]);
            ++i;
        } while (i < n && a[i - 1].first == a[i].first);
        for (; j < i; ++j) upd(a[j].second, d[j]);
    }
    printf("%d\n", ans);
    return 0;
}

/*
7
1 3
4 3
5 1
5 1
3 4
9 4
1 1

*/
