#include <bits/stdc++.h>
using namespace std;

struct FenwickTree{
	
	int n;
	vector<int> val;

	FenwickTree(int _n): n(_n+2){
		val.resize(n+1, 0);
	}

	void upd(int x, int poz){
		poz++;
		for(;poz<=n;poz+=(poz&-poz)){
			val[poz]=max(val[poz], x);
		}
	}

	int query(int poz){
		poz++;
		int sol=-1;
		for(;poz;poz-=(poz&-poz)) sol=max(sol, val[poz]);
		return sol;
	}

};

int main(){
	int n;
	vector<pair<int, int>> rect;
	cin>>n;
	rect.resize(n+1);
	for(int i=1;i<=n;++i){
		cin>>rect[i].first>>rect[i].second;
	}
	sort(rect.begin()+1, rect.end());
	int sol=0;
	FenwickTree aib(30001);
	for(int i=1;i<=n;++i){
		int x=30001-rect[i].second;
		int val=aib.query(x-1)+1;
		aib.upd(val, x);
		sol=max(val, sol);
	}
	cout<<sol<<"\n";
	return 0;
}
