#include <bits/stdc++.h>

using namespace std;

const int N_MAX = 20000;
const int S_MAX = 30000;

int n;

pair <int, int> v[N_MAX];

int BIT[S_MAX + 2];

void update (int pos, int val) {
    for (int i = pos; i >= 1; i -= i & -i) {
        BIT[i] = max(BIT[i], val);
    }
}

int query (int pos) {
    int ans = 0;
    for (int i = pos; i <= S_MAX; i += i & -i) {
        ans = max(ans, BIT[i]);
    }
    return ans;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> v[i].first >> v[i].second;
    }
    sort(v, v + n);

    for (int i = 0; i < n; i++) {
        int cnt = query(v[i].second + 1) + 1;
        update(v[i].second, cnt);
    }

    cout << query(1) << "\n";

    return 0;
}
