#include <bits/stdc++.h>

using namespace std;

struct Rectangle {
	int x, y;
};

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	int n;
	cin >> n;
	vector<Rectangle> rectangles(n);
	for (int i = 0; i < n; ++i) {
		cin >> rectangles[i].x >> rectangles[i].y;
	}

	auto cmp_by_x_then_by_y = [&](const Rectangle &rectangle1, const Rectangle &rectangle2) {
		const auto &[x1, y1] = rectangle1;
		const auto &[x2, y2] = rectangle2;
		return x1 < x2 || (x1 == x2 && y1 < y2);
	};

	sort(rectangles.begin(), rectangles.end(), cmp_by_x_then_by_y);

	vector<int> longest(n, 1);
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (rectangles[i].y > rectangles[j].y) {
				longest[j] = max(longest[j], longest[i] + 1);
			}
		}
	}

	cout << *max_element(longest.begin(), longest.end()) << "\n";

	return 0;
}
