
#include <bits/stdc++.h>


using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define sz(a) a.size()
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)
#define ll long long

struct segment_tree {
    vector<int> t;
    int n;

    segment_tree(int N) {
        n = N;
        t.resize(4 * n, -1);
    }

    void upd(int v, int tl, int tr, int id, int x) {
        if (tl == tr)t[v] = max(t[v], x);
        else {
            int tm = (tl + tr) / 2;
            if (id <= tm)upd(v * 2, tl, tm, id, x);
            else upd(v * 2 + 1, tm + 1, tr, id, x);
            t[v] = max(t[v * 2], t[v * 2 + 1]);
        }
    }

    void upd(int id, int x) {
        upd(1, 0, n - 1, id, x);
    }

    int get_max(int v, int tl, int tr, int l, int r) {
        if (tl > r || l > tr)return -1;
        if (l <= tl && tr <= r)return t[v];
        int tm = (tl + tr) / 2;
        return max(get_max(v * 2, tl, tm, l, r), get_max(v * 2 + 1, tm + 1, tr, l, r));
    }

    int get_max(int l, int r) {
        return get_max(1, 0, n - 1, l, r);
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    set<pair<ll, ll>> s;
    vector<ll> yCord;

    for (int i = 0; i < n; ++i) {
        ll x, y;
        cin >> x >> y;
        s.insert({x, y});
        yCord.push_back(y);
    }

    sort(all(yCord));
    yCord.erase(unique(all(yCord)), yCord.end());

    int res = 0;
    segment_tree st((int)yCord.size());

    for(auto &p : s){
        int y = lower_bound(all(yCord), p.second) - yCord.begin();
        int value = max(0, st.get_max(y, (int)yCord.size() - 1));
        st.upd(y, value + 1);
        ckmax(res, value + 1);
    }

    cout << res;
}