/**
 * Author: MatijaL
 * Time: 2021-11-25 13:19:33
**/

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define pll pair<ll, ll>
#define loop(i, n) for(ll i = 0; i < n; i++)
#define FOR(i,n,m) for(ll i = n; i <= m; i++)
#define isIn(vec, item) find(vec.begin(), vec.end(), item) != vec.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define all(v) v.begin(),v.end()
#define inf 1000000005
#define mod 1000000007
#define print(v) for(auto e : v) cout << e << " "; cout << endl;


int par[20500];
int sz[20500];

int find(int a){
    if(par[a] == a) return a;
    return par[a] = find(par[a]);
}
void un(int a, int b){
    a = find(a);b=find(b);
    if(a==b) return;
    if(sz[a] < sz[b]) swap(a, b);
    par[b] = a;
    sz[a] += sz[b];
}

void solve(){

    int N;
    cin >> N;
    set<pll> s;
    loop(i, N){
        int a, b;
        cin >> a >> b;
        s.insert(mp(a, b));
    }
    vector<pll> nodes;
    for(auto e : s) nodes.pb(e);
    N = nodes.size();
    vector<int> otroci[N];
    vector<int> in(N, 0);
    loop(i, N){
        par[i] = i;
        sz[i] = 1;
        loop(j, N){
            if(i==j) continue;
            if(nodes[i].fs <= nodes[j].fs and nodes[i].sc <= nodes[j].sc){
                in[i]++;
                otroci[j].pb(i);
                un(i, j);
            }
        }
    }
    ll ans = 0;
    vector<int> comps[N];
    loop(i, N) if(in[i] == 0) comps[find(i)].pb(i);

    loop(i, N){
        if(comps[i].empty()) continue;
        vector<int> cur = comps[i];
        vector<int> next;

        int mx = 0;
        while(!cur.empty()){
            mx = max(mx,(int) cur.size());
            for(auto e : cur){
                for(auto f : otroci[e]){
                    in[f]--;
                    if(in[f] == 0) next.pb(f);
                }
            }
            cur = next;
            next.clear();
        }
        ans += mx; 
    }
    cout << ans << endl;
}

int main(){

    ios::sync_with_stdio(0);
    cin.tie(0);
    
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    solve();  
}
