#include <algorithm>
#include <iostream>
#include <utility>
#define endl '\n'
using namespace std;

const int MAXN = 20000;

int lis[MAXN + 5];
pair<int, int> p[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> p[i].first >> p[i].second;
    }

    sort(p + 1, p + n + 1);

    int cnt = 1;
    lis[1] = p[n].second;
    for (int i = n - 1; i > 0; -- i)
    {
        if (p[i].second < lis[1]) lis[1] = p[i].second;
        else if (p[i].second > lis[cnt])
        {
            cnt++;
            lis[cnt] = p[i].second;
        }
        else
        {
            int pos = lower_bound(lis + 1, lis + cnt + 1, p[i].second) - lis;
            lis[pos] = p[i].second;
        }
    }

    cout << cnt << endl;

    return 0;
}
