#include<bits/stdc++.h>
using namespace std;
const int maxn = 1024;
const int inf = 1000000000;
struct edge
{
    int to;
    int cap;
    int idx;
    edge(){};
    edge(int to1 , int cap1, int idx1)
    {
        to = to1;
        cap = cap1;
        idx = idx1;
    }
};
int n,m,s,t;
vector< edge >v[maxn];
int lvl[maxn];
int t_i[maxn];
void read()
{
    cin >> n >> m;
    t = n;
    s = 1;
    for(int i=1;i<=m;i++)
    {
        int x,y,z;
        cin >> x >> y >> z;
        v[x].push_back( edge(y,z,v[y].size()) );
        v[y].push_back( edge(x,0,v[x].size()-1) );
    }
}
bool bfs()
{
    memset(lvl,0,sizeof(lvl));
    lvl[s] = 1;
    queue<int>q;
    q.push(s);
    while( !q.empty() )
    {
        int w = q.front();
        q.pop();
        int sz = v[w].size();
        for(int i=0;i<sz;i++)
        {
            int nb = v[w][i].to;
            int t_cap = v[w][i].cap;
            if( lvl[nb] == 0 && t_cap > 0 )
            {
                lvl[nb] = lvl[w] + 1;
                q.push(nb);
            }
        }
    }
    if( lvl[t] == 0 ) return 0;
    else return 1;
}
int dfs(int w, int t_min )
{
    if( w == t ) return t_min;
    int sz = v[w].size();
    for(int i=t_i[w];i<sz;i++)
    {
        int nb = v[w][i].to;
        int t_cap = v[w][i].cap;
        int rev_idx  = v[w][i].idx;
        if( lvl[nb] == lvl[w] + 1 && t_cap > 0 )
        {
            int t_dfs = dfs(nb,min(t_min,t_cap));
            if( t_dfs != 0 )
            {
                v[w][i].cap -= t_dfs;
                v[nb][rev_idx].cap += t_dfs;
                return t_dfs;
            }
        }
        t_i[w] ++;
    }
    return 0;
}
void take_max_flow()
{
    int max_f = 0;
    while( bfs() == 1 )
    {
        memset(t_i,0,sizeof(t_i));
        while( true )
        {
            int t_dfs = dfs(s,inf);
            max_f += t_dfs;
            if( t_dfs == 0 ) break;
        }
    }
    cout << max_f << endl;
}
int main()
{
    read();
    take_max_flow();
    return 0;
}
