#include <iostream>
#include <vector>

using namespace std;

int n;
vector<pair<int,int> > v;

int gr[20000][20000];

void init()
{
	scanf("%d",&n);
	int a,b;
	
	for(int i=0;i<n;i++)
	{
		scanf("%d%d",&a,&b);
		v.push_back(make_pair(a,b));
	}
}

void makeGraph()
{
	for(int i=0;i<n;i++)
	{
		for(int j=i+1;j<n;j++)
		{
			if(v[i].first>=v[j].first&&v[i].second>=v[j].second)
				gr[i][j]=1;
			if(v[i].first<=v[j].first&&v[i].second<=v[j].second)
				gr[j][i]=1;
		}
	}
}

void printGraph()
{
	for(int i=0;i<n;i++)
	{
		for(int j=0;j<n;j++)
		{
			cout<<gr[i][j]<<" ";
		}
		cout<<endl;
	}
}

bool used[20000];
int larg(int x)
{
	int ans=0;
	
	for(int i=0;i<n;i++)
		if(!used[i]&&gr[x][i])
		{
			used[i]=true;
			ans=max(ans,larg(i)+1);
			used[i]=false;
		}
	
	return ans;
}

int main()
{
	init();
	makeGraph();
	
	int ans=larg(0);
	for(int i=1;i<n;i++)
		ans=max(ans,larg(i));
	
	if(ans==0) cout<<1<<endl;
    else cout<<ans<<endl;
}
