#include <iostream>
#include <algorithm>
#include <stack>
using namespace std;
const int MAXN=2e4+10;
struct Rect {
    int x, y;
};
Rect a[MAXN];
int lsi[MAXN], br;
stack <int> st;
bool cmp(Rect a, Rect b) {
    if (a.x!=b.x) return a.x<b.x;
    return a.y>b.y;
}
void add(int x) {
    if (br==0 || x<lsi[br-1]) {
        lsi[br]=x;
        br++;
        return;
    }
    int l, r, mid;
    l=0; r=br-1;
    while (l<=r) {
        mid=(l+r)/2;
        if (lsi[mid]>x) l=mid+1;
        else r=mid-1;
    }
    lsi[l]=x;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i=0;i<n;i++) cin >> a[i].x >> a[i].y;
    sort(a,a+n,cmp);
    br=0;
    for (int i=0;i<n;i++) {
        if (i!=0 && a[i].y==a[i-1].y) continue;
        add(a[i].y);
    }
    cout << br << endl;
    return 0;
}
