#include <iostream>
#include <algorithm>
using namespace std;
const int MAXN=2e4+10;
struct Rect {
    int x, y;
};
Rect a[MAXN];
int dp[MAXN];
int lsi[MAXN], br;
bool cmp(Rect a, Rect b) {
    if (a.x!=b.x) return a.x<b.x;
    return a.y>b.y;
}
void add(int x) {
    if (br==0 || x<lsi[br-1]) {
        lsi[br]=x;
        br++;
        return;
    }
    int l, r, mid;
    l=0; r=br-1;
    while (l<=r) {
        mid=(l+r)/2;
        if (lsi[mid]>x) l=mid+1;
        else r=mid-1;
    }
    lsi[l]=x;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i=0;i<n;i++) cin >> a[i].x >> a[i].y;
    sort(a,a+n,cmp);
    br=0;
    dp[0]=1;
    int ans=1;
    for (int i=1;i<n;i++) {
        dp[i]=1;
        for (int j=i-1;j>=0;j--) {
            if (a[i].x==a[j].x) continue;
            if (a[i].y<a[j].y) dp[i]=max(dp[i],dp[j]+1);
        }
        ans=max(dp[i],ans);
    }
    cout << ans << endl;
    return 0;
}
