#include <bits/stdc++.h>
#define GLHF ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)
using namespace std;
typedef long long ll;
typedef vector<int>vi;
typedef vector<pair<int,int>> vpi ;

#define all(x) x.begin(),x.end()
#define out(x) {cout << x << "\n"; return;}

template <typename T>void read(vector<T>& a){
    int n=a.size();
    for(int i=0; i<n; i++)
        cin >> a[i];
}
void solve();
int main(){
    GLHF;
    solve();
}

struct seg{
    int sz=1;
    vi t;

    seg(int n){
        while(sz<=2*n)
            sz*=2;
        t.resize(sz);
    }

    void upd(int i,int v){
        i+=sz/2;
        t[i]=max(t[i],v);

        while(i){
            t[i/2]=max(t[i],t[i^1]);
            i/=2;
        }
    }
    int qur(int l,int r){
        int ans=0;
        for(l+=sz/2 , r+=sz/2 +1; l<r ;l/=2,r/=2){
            if(l&1)ans=max(ans,t[l++]);
            if(r&1)ans=max(ans,t[--r]);
        }
        return ans;
    }
};
void solve(){
    int n;
    cin >> n;
    vpi a(n);

    for(int i=0; i<n; i++)
        cin >> a[i].first >> a[i].second;

    sort(all(a));
    const int maxn=3e4+2;

    seg s(maxn+1);
    int ans=0;

    for(int i=0; i<n; i++){
        int cur=s.qur(a[i].second+1,maxn-1);
        ans=max(ans,cur+1);
        s.upd(a[i].second,cur+1);
    }
    out(ans)
}