#include <iostream>
#include <algorithm>
#include <map>
#include <cmath>

struct rect {
	int posx, posy;
	bool operator< (const rect& nr2) const {
		return ((posx == nr2.posx) ? (posy < nr2.posy) : (posx < nr2.posx));
	}
} vec[20005];

std::map <int, int> sav;

int main() {
	std::map <int, int>::iterator posi, posf;
	int nrn;
	int val, ans;
	std::cin >> nrn;
	for (int index = 0; index < nrn; index++) {
		std::cin >> vec[index].posx >> vec[index].posy;
	}
	std::sort(vec, vec + nrn);
	ans = 1;
	for (int index = nrn - 1; index >= 0; index--){
		posi = sav.lower_bound(vec[index].posy);
		if (posi == sav.begin()) {
			val = 1;
			sav[vec[index].posy] = val;
		}
		else {
			posi--;
			val = posi->second + 1;
			ans = std::max(ans, val);
			sav[vec[index].posy] = std::max(sav[vec[index].posy], val);
		}
		posi = sav.upper_bound(vec[index].posy);
		posf = posi;
		while (posf != sav.end()) {
			if (posf->second <= val) {
				posf++;
			}
			else {
				break;
			}
		}
		if (posi != posf) {
			sav.erase(posi, posf);
		}
	}
	std::cout << ans;
}