#include <bits/stdc++.h>

using namespace std;

vector<pair<int, int>> pts;

int get_lds() {
    vector<vector<int>> helper;
    unordered_map<int, int> sol;
    for(auto e : pts) {
        int val = -e.second;

        int poz = helper.size();
        int step = 1;
        while(step < poz) step *= 2;

        for(; step > 0; step /= 2) {
            if(0 <= poz - step && helper[poz - step].back() <= val)
                poz -= step;
        }

        if(helper.size() == poz)
            helper.push_back(vector<int>(0));
        helper[poz].push_back(val);

        if(poz == 0) sol[val] = 0;
        else sol[val] = sol[helper[poz - 1].back()] + 1;
    }

    int maxim = 0;
    for(auto e : sol) {
        maxim = max(maxim, e.second);
    }

    return maxim;
}

int main() {
    int n; cin >> n;
    pts.resize(n);
    for(auto &e : pts)
        cin >> e.first >> e.second;
    sort(pts.begin(), pts.end());

    cout << get_lds();
}
