#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

const int N = 20000;

int bit[N+5];

int bit_get(int x){
    int res = 0;
    while(x){
        res = max(res, bit[x]);
        x -= x & -x;
    }
    return res;
}

void bit_add(int x, int val){
    while(x <= N){
        bit[x] = max(bit[x], val);
        x += x & -x;
    }
}

pair <int, int> a[N+5];

int main(){
    ios_base::sync_with_stdio(false), cin.tie(0);
	cout.precision(10);
	cout << fixed;

	int n;
	cin >> n;
	for(int i=1; i<=n; i++) cin >> a[i].first >> a[i].second;
    sort(a+1, a+1+n);
    reverse(a+1, a+1+n);
    int res = 1;
    for(int i=1; i<=n; i++){
        int x = 1 + bit_get(a[i].second - 1);
        res = max(res, x);
        bit_add(a[i].second, x);
    }
    cout << res << "\n";
    return 0;
}
