#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define LD long double
#define INF (1<<30)

struct rect{
    int x, y;
    rect(){}
    rect( int _x, int _y ) : x(_x), y(_y) {} 

    const bool operator < ( const rect &o ){
        if( x != o.x ) return x < o.x;
        return y > o.y;
    }
};

int main(){ ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int N; cin >> N;
    rect A[N];

    for( int i = 0 ; i < N ; i++ ) cin >> A[i].x >> A[i].y;

    sort( A, A+N );

    int maxSize = 1, currentSize = 0, maxY = 0;
    for( int i = 0 ; i < N ; i++ ){
        if( A[i].y >= maxY ){
            maxY = A[i].y;
            currentSize = 1;
        }else if( !i || A[i].x != A[i-1].x ) currentSize++;
        maxSize = max( maxSize, currentSize );
    }

    cout << maxSize << endl;

    // for( int i = 0 ; i < N ; i++ ){
    //     cout << A[i].x << ' ' << A[i].y << endl;
    // }

}

/*

8
1 3
4 3
5 1
5 2
3 4
9 4
1 1
10 1

4
3 4
4 3
5 2
10 1


*/