#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define LD long double
#define INF (1<<30)

struct rect{
    int x, y;
    rect(){}
    rect( int _x, int _y ) : x(_x), y(_y) {} 

    const bool operator < ( const rect &o ){
        if( x != o.x ) return x < o.x;
        return y > o.y;
    }
};

int F( int, int );

const int maxN = 20005;
int N;
int dp[maxN][maxN];
rect A[maxN];

int main(){ ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    memset( dp, -1, sizeof dp );

    cin >> N;
    for( int i = 0 ; i < N ; i++ ) cin >> A[i].x >> A[i].y;
    sort( A, A+N );

    int maxRes = 0;
    for( int i = 0 ; i < N ; i++ ) maxRes = max( maxRes, F( i+1, i ) + 1 );

    cout << maxRes << endl;

}

int F( int i, int heightLimitIdx ){

    if( i == N || A[heightLimitIdx].y == 1 ) return 0;

    if( dp[i][heightLimitIdx] != -1 ) return dp[i][heightLimitIdx];

    rect parent = A[heightLimitIdx];
    if( A[i].x == parent.x || A[i].y >= parent.y ) return dp[i][heightLimitIdx] = F( i+1, heightLimitIdx );

    return dp[i][heightLimitIdx] = F( i+1, i ) + 1;

}

/*

8
1 3
4 3
5 1
5 2
3 4
9 4
1 1
10 1

4
3 4
4 3
5 2
10 1


*/