#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define LD long double
#define INF (1<<30)

struct rect{
    int x, y;
    rect(){}
    rect( int _x, int _y ) : x(_x), y(_y) {} 

    const bool operator < ( const rect &o ){
        if( x != o.x ) return x < o.x;
        return y > o.y;
    }
};

const int maxN = 20005;
int N;
int dp[maxN];
rect A[maxN];

int main(){ ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    memset( dp, -1, sizeof dp );

    cin >> N;
    for( int i = 0 ; i < N ; i++ ) cin >> A[i].x >> A[i].y;
    sort( A, A+N );

    for( int i = N-1 ; i >= 0 ; i-- ){
        dp[i] = 0;
        for( int j = i+1 ; j < N ; j++ ){
            if( A[i].x == A[j].x || A[j].y >= A[i].y ) continue;
            dp[i] = max( dp[i], dp[j]+1 );
        }
    }

    int maxRes = 0;
    for( int i = 0 ; i < N ; i++ ) maxRes = max( maxRes, dp[i]+1 );

    cout << maxRes << endl;

}

/*

8
1 3
4 3
5 1
5 2
3 4
9 4
1 1
10 1

4
3 4
4 3
5 2
10 1


*/