#include <iostream>
#include <iomanip>
#include <algorithm>

using namespace std;
#define int long long

int n;
pair <int, int> a[20010];
pair <int, int> ans[20010];
const int INF = 1e18;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i].first >> a[i].second;
		a[i].second *= -1;
	}

	sort(a + 1, a + 1 + n);
	for (int i = 1; i <= n + 1; ++i) ans[i] = { INF, INF };
	ans[0] = { -INF, -INF };

	for (int i = 1; i <= n; ++i)
	{
		swap(a[i].first, a[i].second);
		auto got = lower_bound(ans, ans + n + 1, a[i]) - ans;
		ans[got] = a[i];
	}

	int i = 0;
	while (ans[i].first != INF) ++i;
	cout << i - 1;
	return 0;
}