#include <iostream>
#include <iomanip>
#include <algorithm>

using namespace std;
#define int long long

int n;
pair <int, int> a[20010];
int ans[20010];
const int INF = 1e18;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i].first >> a[i].second;
	}

	sort(a + 1, a + 1 + n);
	for (int i = 1; i <= n + 1; ++i) ans[i] = INF;
	ans[0] = -INF;

	for (int i = 1; i <= n; ++i)
	{
		a[i].second *= -1;
		auto got = lower_bound(ans, ans + n + 1, a[i].second) - ans;
		ans[got] = a[i].second;
	}

	int i = 0;
	while (ans[i] != INF) ++i;
	cout << i - 1;
	return 0;
}