#include <bits/stdc++.h>
//#include "guess.h"

using namespace std;
typedef long long ll;

const int NMAX = 20001;

int match[NMAX];
int viz[NMAX];
pair <int, int> v[NMAX];
vector <int> g[NMAX];

void addEdge(int a, int b){
    g[a].push_back(b);
    g[b].push_back(a);
}

bool DFS(int node){
    viz[node] = 1;
    for(auto x : g[node]){
        if(!match[x]){
            match[x] = node;
            match[node] = x;
            return 1;
        }
        if(viz[match[x]])
            continue;

        if(DFS(match[x])){
            match[x] = node;
            match[node] = x;
            return 1;
        }
    }
    return 0;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, i;
    cin >> n;
    for(i = 1; i <= n; i++){
        cin >> v[i].first >> v[i].second;
        for(int j = 1; j < i; j++){
            if(v[j].first >= v[i].first && v[i].second <= v[j].second)
            {
                addEdge(i, j);
            }
        }
    }
    int ok = 1, cuplaj = 0;
    while(ok){
        ok = 0;
        for(int i = 1; i <= n; i++){
            viz[i] = 0;
        }
        for(i = 1; i <= n; i++){
            if(!match[i] && !viz[i]){
                ok |= DFS(i);
            }
        }
    }
    for(i = 1; i <= n; i++){
        if(match[i])
            cuplaj++;
    }
    cout << n - cuplaj;
}

