#include <bits/stdc++.h>
using namespace std;
int n, i, j;
#define X first
#define Y second
pair<int, int> a[20005];
vector<pair<int, int> > p;
int colors[20005];
int cc[20005];
vector<int> to[20005];
vector<int> fr[20005];
vector<int> members[20005];
bool visited[20005];
int ans;
bool ok;
vector<int> topo;

void dfs(int x) {
  visited[x] = true;
  for (auto y : fr[x])
    if (!visited[y])
      dfs(y);

  topo.push_back(x);
}

int main() {
  scanf("%d", &n);
  for (i=0; i < n; ++i) scanf("%d%d", &a[i].X, &a[i].Y);
  sort(a, a+n);
  p.push_back(a[0]);

  for (i=1; i < n; ++i) if (a[i] != a[i-1]) p.push_back(a[i]);
  n = (int)p.size();

  for (i=0; i < n; ++i) {
    for (j=0; j < n; ++j) {
      if (i == j) continue;

      if (p[i].X <= p[j].X && p[i].Y <= p[j].Y) {
        fr[j].push_back(i);
        to[i].push_back(j);
      }
    }
  }

  //Find topo sort
  for (i=0; i < n; ++i)
    if (!visited[i]) dfs(i);

  reverse(topo.begin(), topo.end());

  //Color
  for (i=0; i < n; ++i) {
    fill(cc, cc+20004, 0);

    for (auto edge : to[topo[i]]) {
      ++cc[colors[edge]];
    }

    for (j=1; j <= 20000; ++j) {
      if (cc[j] == 0) {
        colors[topo[i]] = j;
        break;
      }
    }

    members[colors[topo[i]]].push_back(topo[i]);
  }

  ans = 1;

  for (i=1; i <= 20000; ++i) ans = max(ans, (int)members[i].size());

  printf("%d\n", ans);
  return 0;
}
