#include <bits/stdc++.h>

using namespace std;
#define dbg(x) cerr << #x << " " << x << "\n"
const int MX = 3e4;
int aib[1 + MX];
void upd(int pos, int val) {
    while (pos <= MX) {
        aib[pos] = max(aib[pos], val);
        pos += pos & -pos;
    }
}
int qry(int pos) {
    int ans = 0;
    while (pos > 0) {
        ans = max(ans, aib[pos]);
        pos -= pos & -pos;
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    vector <pair <int, int>> rect;
    for (int i = 1; i <= n; i++) {
        int x, y;
        cin >> x >> y;
        rect.push_back({x, y});
    }
    sort(rect.begin(), rect.end());
    int ans = 0;
    for (int i = n - 1; i >= 0; i--) {
        int j = i;
        vector <pair <int, int>> to_add;
        while (j >= 0 && rect[i].first == rect[j].first) {
            to_add.push_back({rect[j].second, qry(rect[j].second - 1)});
        //    dbg(to_add.back().first); dbg(to_add.back().second); dbg(rect[j].first);
            j--;
        }
        for (pair <int, int> update : to_add) {
            ans = max(ans, update.second + 1);
            upd(update.first, update.second + 1);
        }
        i = j + 1;
    }
    cout << ans << "\n";
    return 0;
}
/**
x1 y1
x2 y2
x3 y3
x1 < x2 < x3
y1 > y2 > y2
**/
