#include <bits/stdc++.h>

using namespace std;
using pi = pair<int, int>;

template<class T> bool ckmin(T& a, T b) { return b < a ? a = b, true : false; }

void stress() {
    mt19937 rng(1337228);
    const int n = 1000;
    vector g(n, vector<int>(n));
    auto distr = uniform_int_distribution<int>(1, 1e6);
    for (auto& u : g) for (int& x : u) x = distr(rng);

    for (int k = n; k--; )
    for (int i = n; i--; )
    for (int j = n; j--; ) {
        ckmin(g[i][j], g[i][k] + g[k][j]);
    }
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int n; cin >> n;
    vector<pi> v(n);
    for (auto& [x, y] : v) cin >> x >> y;
    sort(v.begin(), v.end());
    v.erase(unique(v.begin(), v.end()), v.end());

    vector<int> st;

    stress();

    st.push_back(numeric_limits<int>::min());

    for (auto [x, y] : v) {
        y = -y;
        auto it = lower_bound(st.begin(), st.end(), y);
        if (it == st.end()) {
            st.emplace_back(y);
        } else {
            *it = y;
        }
    }

    cout << st.size() - 1 << '\n';
}