#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;

bool comp(pll val1, pll val2)
{
	if (val1.first == val2.first)
		return val1.second > val2.second;
	return val1.first > val2.first;
}

int main()
{
	ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	ll n;
	cin >> n;

	vector<pll> rec(n);
	for (ll i = 0; i < n; i++)
		cin >> rec[i].first >> rec[i].second;

	sort(rec.begin(), rec.end(), comp);

	set<ll> lis;
	for (ll i = 0; i < n; i++)
	{
		auto it = lis.lower_bound(rec[i].second);
		if (it != lis.end())
			lis.erase(it);
		lis.insert(rec[i].second);
	}

	cout << lis.size();
	return 0;
}