#include <iostream>
using namespace std;

struct Point {
	int x, y;
};

bool doOverlap(Point 11, Point r1, Point 12, Point r2){
	if(11.x == r1.x || 11.y == r1.y || 12.x == r2.x || 12.y == r2.y){
		return false;
	}
	
	if(11.x >= r2.x || 12.x >= r1.x){
		return false;
	}
	
	if(r1.y >= 12.y || r2.y >= 11.y){
		return false;
	}
	
	return true;
}

int main() {
	Point 11 = { 0, 10 }, r1 = { 10, 0 };
	Point 12 = { 5, 5 }, r2 = { 15, 0 };
	if(doOverlap(11, r1, 12, r2)){
		cout << "Rectangles overlap" << endl;
	} else {
		cout << "Rectangles don't overlap" << endl;
	}
	
	return 0;
}