#include "bits/stdc++.h"

using namespace std;

using ll = int_fast64_t;

int INF = 1<<30;

void solve(){
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i].first >> v[i].second;
    }
    v.emplace_back(0, INF);
    sort(v.begin(),  v.end());
    vector<pair<int, int>> dp(n + 1);
    for (int i = 0; i < n + 1; ++i) {
        dp[i] = {1, v[i].second};
        for (int j = 0; j < i; ++j) {
            if(v[i].second < dp[j].second &&
            (dp[i].first < dp[j].first + 1 ||
            dp[i].first == dp[j].first && dp[i].second < dp[j].second)){
                dp[i] = dp[j];
                ++dp[i].first;
                dp[i].second = min(dp[i].second, v[i].second);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans = max(ans, dp[i].first);
    }
    cout << ans - 1;
}

int main(){
    solve();
    return 0;
}