#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <iostream>
#include "guess.h"
using namespace std;
const long long int INF = 1e19;

void guess(){
    long long int currNum;
    long long int hi = INF;
    long long int lo = 0;
    if(quest(1e12) == 0){
        res(currNum);
        return;
    }
    if(quest(1e12) == 1){
        lo = 1e12;
    }
    else if(quest(1e6) == 0){
        res(currNum);
        return;
    }
    else if(quest(1e6) == 1){
        lo = 1e6;
        hi = 1e12;
    }
    else{
        lo = 0;
        hi = 1e6;
    }

    // long long int hi = INF;
    // long long int lo = 0;
    long long int currResult;
    while(lo<hi){
        currNum = (lo+hi)/2;
        currResult = quest(currNum);
        if(currResult == 0){
            break;
        }
        else if(currResult == 1){
            lo = currNum;
        }
        else{
            hi = currNum;
        }
    }
    res(currNum);
}