#include<bits/stdc++.h>
using namespace std;

const int N = 2e5;
int t[4 * N];

void modif(int i, int l, int r, int pos, int val){
    if(l > pos || r < pos)return;

    if(l == pos && r == pos){
        t[i] = val;
        return;
    }
    int mid = l + r >> 1;

    modif(2 * i, l, mid, pos, val);
    modif(2 * i + 1, mid + 1, r, pos, val);
    t[i] = max(t[2 * i], t[2 * i + 1]);
}
int query(int i, int l, int r, int tl, int tr){
    if(l > tr || r < tl)return 0;
    if(l >= tl && r <= tr)return t[i];
    int mid = l + r >> 1;
    return max(query(2 * i, l, mid, tl, tr), query(2 * i + 1, mid + 1, r, tl, tr));
}

void solve(){
    int n;
    cin >> n;
    vector<pair<int,int>> a(n);
    for(int i = 0;i < n; ++i){
        cin >> a[i].first >> a[i].second;
    }
    sort(a.begin(), a.end());

    vector<int> dp(n, 1);
    int ans = 1;
    modif(1, 0, N - 1, a[0].second, 1);
    for(int i = 1;i < n; ++i){
        dp[i] = max(dp[i], query(1, 0, N - 1, a[i].second + 1, N - 1) + 1);
        ans = max(ans, dp[i]);
        modif(1, 0, N - 1, a[i].second, dp[i]);
    }

    cout << ans << "\n";
}

int32_t main(){
    int t = 1;
    while(t--){
        solve();
    }
}
