#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
//#include “guess.h”
#include <cstdio>
using namespace std;

#ifndef ONLINE_JUDGE
#define dbg(x) cerr << #x <<" "; print(x); cerr << endl;
#else
#define dbg(x)
#endif

#define sz(x) (int((x).size()))
#define len(x) (int)x.length()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define pf push_front
#define pb push_back
#define popf pop_front
#define popb pop_back
#define ft front
#define bk back

void print(long long t) {cerr << t;}
void print(int t) {cerr << t;}
void print(string t) {cerr << t;}
void print(char t) {cerr << t;}
void print(double t) {cerr << t;}
void print(unsigned long long t) {cerr << t;}

template <class T, class V> void print(pair <T, V> p);
template <class T> void print(vector <T> v);
template <class T> void print(set <T> v);
template <class T, class V> void print(map <T, V> v);
template <class T> void print(multiset <T> v);
template <class T> void print(T v[],T n) {cerr << "["; for(int i = 0; i < n; i++) {cerr << v[i] << " ";} cerr << "]";}
template <class T, class V> void print(pair <T, V> p) {cerr << "{"; print(p.first); cerr << ","; print(p.second); cerr << "}";}
template <class T> void print(vector <T> v) {cerr << "[ "; for (T i : v) {print(i); cerr << " ";} cerr << "]";}
template <class T> void print(set <T> v) {cerr << "[ "; for (T i : v) {print(i); cerr << " ";} cerr << "]";}
template <class T> void print(multiset <T> v) {cerr << "[ "; for (T i : v) {print(i); cerr << " ";} cerr << "]";}
template <class T, class V> void print(map <T, V> v) {cerr << "[ "; for (auto i : v) {print(i); cerr << " ";} cerr << "]";}
template <class T, class V> void print(unordered_map <T, V> v) {cerr << "[ "; for (auto i : v) {print(i); cerr << " ";} cerr << "]";}

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
#define nl '\n'


// lowest / (1 << 17) >= 1e5 / (1 << 18) >= 2e5
void fastIO() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr); cout.tie(nullptr);
}
// file in/out
void setIO(string str = "") {
  fastIO();

  if(str != "") {
    freopen((str + ".in").c_str(), "r", stdin);
    freopen((str + ".out").c_str(), "w", stdout);
  }
}
// Indexed Set
template <class T> using Tree = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

int main () {
  setIO();
  int n; cin >> n;
  set<pair< int, int>> a;
  vector<pair<int, int>> p, b, d;
  vector<int> its(n, 0);
  for(int i = 0; i < n; i++) {
    int x, y; cin >> x >> y;
    a.insert({x, y});
  }

  int ind = 0;
  for(auto i: a) {
    b.pb({i.first, ind});
    d.pb({i.second, ind++});
    p.pb({i.first, i.second});
  }

  n = sz(a);
  sort(all(d));

//  dbg(b)
//  dbg(d)
//  dbg(p)

  int ans = 1;
  for(int i = 0; i < n; i++) {
    bitset<10> bit;

    for(int j = i + 1; j < n; j++) {
      if(p[b[j].second].second <= p[b[i].second].second) {
        bit[b[j].second] = 1;
      }
    }

    int sc = p[b[i].second].second;
    for(int j = sc + 1; j < n; j++) {
      if(p[d[j].second].first <= p[d[i].second].first) {
        bit[d[j].second] = 1;
      }
    }

//    cout << bit << endl;
    ans = max(ans,(int)bit.count());
  }

  cout << ans << endl;
  return 0;
}