#include <bits/stdc++.h>
using namespace std;

const int maxn = 20004, maxl = 30004;
int n;
pair <int, int> rect [maxn];
int cnt_max;

int tree [4 * maxl];
void update (int l, int r, int pos, int x, int val){
    if (l == r){
        tree [pos] = val;
        return;
    }
    int mid = l + r >> 1;
    if (x <= mid) update (l, mid, pos << 1, x, val);
    else update (mid + 1, r, pos << 1 | 1, x, val);
    tree [pos] = max (tree [pos << 1], tree [pos << 1 | 1]);
}
int query (int l, int r, int pos, int ql, int qr){
    if (l >= ql && r <= qr) return tree [pos];
    if (l > qr || r < ql) return 0;
    int mid = l + r >> 1;
    return max (query (l, mid, pos << 1, ql, qr), query (mid + 1, r, pos << 1 | 1, ql, qr));
}

int main (){

    cin >> n;
    for (int i = 0; i < n; i ++) cin >> rect [i].first >> rect [i].second;
    sort (rect, rect + n);

    for (int i = 0; i < n; i ++){
        int cnt_curr = query (1, maxl, 1, rect [i].second + 1, maxl) + 1;
        cnt_max = max (cnt_max, cnt_curr);
        update (1, maxl, 1, rect [i].second, cnt_curr);
    }

    cout << cnt_max << '\n';

}