#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 20003
using namespace std;
int n;
pair <int, int> rect[MAXN];
int dp[MAXN];
int max1 = 1;

void input()
{
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> rect[i].first >> rect[i].second;
}

bool check(pair <int, int> p1, pair <int, int> p2)
{
    return p1.first <= p2.first && p1.second <= p2.second;
}

void solve()
{
    sort (rect, rect + n + 1);

    dp[0] = 0;
    dp[1] = 1;

    for (int i = 2; i <= n; ++i)
    {
        dp[i] = 1;
        for (int j = 0; j < i; ++j)
            if (!check(rect[j], rect[i]))
                dp[i] = max(dp[i], dp[j] + 1);

        max1 = max(max1, dp[i]);
    }

    cout << max1 << endl;
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}

/**

7
1 3
4 3
5 1
5 1
3 4
9 4
1 1

*/
