#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n;
vector<pair<int, int>> r;

void read() {
    cin >> n;

    r.resize(n);
    for (auto &i : r) {
        cin >> i.first >> i.second;
    }
}

void solve() {
    sort(r.begin(), r.end());

    vector<int> dp(n);
    int answer = 1;
    dp[0] = 1;
    for (int i = 1; i < n; i++) {
        dp[i] = 1;
        for (int j = 0; j < i; j++) {
            if (r[j].second > r[i].second) {
                dp[i] = max(dp[i], dp[j] + 1);
            }
        }

        answer = max(answer, dp[i]);
    }

    cout << answer << endl;
}

int main() {
    setIO();

    read();

    solve();
}
