#include <bits/stdc++.h>
#include "guess.h"

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const long long HIGH_LIM = 1e18;

void guess() {
    long long low = 1, high = HIGH_LIM;
    long long answer = -1;

    while (high > 1) {
        int code = quest(high >> 1);
        if (code == 2) {
            high >>= 1;
        } else {
            break;
        }
    }

    while ((low << 1) < high) {
        int code = quest(low << 1);
        if (code == 1) {
            low <<= 1;
        } else {
            break;
        }
    }

    while (low <= high) {
        long long mid = low + ((high - low) >> 1);
        int code = quest(mid);

        if (code == 0) {
            answer = mid;
            break;
        } else if (code == 1) {
            low = mid + 1;
        } else {
            high = mid - 1;
        }
    }

    res(answer);
}
