#include<iostream>
#include<algorithm>
#include<cmath>
#include<cstring>
#include<string>
#include<vector>
#include<stack>
#include<queue>
#include<deque>
#include<cstdio>
#include<map>
#include<set>
using namespace std;
struct Treap
{
    struct Node
    {
        int key,sz,pr;
        Node *l,*r;
        Node(){l=r=NULL;}
        Node(int _key)
        {
            key=_key;
            sz=1;
            pr=rand();
            l=r=NULL;
        }
        void con()
        {
            sz=1;
            if(l)sz+=l->sz;
            if(r)sz+=r->sz;
        }
    };

    Node *root;
    Treap(){root=NULL;}

    void Split(Node *T,Node *&L,Node *&R,int key)
    {
        if(T==NULL)
        {
            L=R=NULL;
            return;
        }
        if(key>=T->key)
        {
            L=T;
            Split(T->r,L->r,R,key);
        }
        else
        {
            R=T;
            Split(T->l,L,R->l,key);
        }
        T->con();
    }

    void Merge(Node *&T,Node *L,Node *R)
    {
        if(L==NULL)
        {
            T=R;
            return;
        }
        if(R==NULL)
        {
            T=L;
            return;
        }
        if(L->pr > R->pr)
        {
            T=L;
            Merge(T->r,L->r,R);
        }
        else
        {
            T=R;
            Merge(T->l,L,R->l);
        }
        T->con();
    }

    int Insert_with_ans(int key)
    {
        Node *L,*R,*N=new Node(key);
        Split(root,L,R,key);
        int ans=0;
        if(L!=NULL)ans=L->sz;
        Merge(L,L,N);
        Merge(root,L,R);
        return ans;
    }
};
Treap T;
const int maxn=20010;
int n;
pair<int,int>point[maxn];
int t[maxn*2];
void update(int root,int l,int r,int pos,int val)
{
    if(l==r)
    {
        t[root]=val;
        return;
    }
    int mid=(l+r)/2;
    if(pos>mid)update(root*2,l,mid,pos,val);
    else update(root*2+1,mid+1,r,pos,val);
    t[root]=max(t[root*2],t[root*2+1]);
}
int main()
{
	/*ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);*/
	scanf("%d",&n);
	for(int i=1;i<=n;i++)
        scanf("%d%d",&point[i].first,&point[i].second);
    sort(point+1,point+n+1);
    int ans=1,rez;
    pair<int,int>prev;
    prev=point[1];
    T.Insert_with_ans(point[1].second);
    update(1,1,n,1,1);
    for(int i=2;i<=n;i++/*,cout<<endl*/)
    {
        //cout<<point[i].first<<' '<<point[i].second<<endl;
        if(point[i]==prev)continue;
        rez=T.Insert_with_ans(point[i].second);
        update(1,1,n,i,rez);

        ans=max(ans,i-t[1]);
        //cout<<ans<<' '<<t[1]<<' '<<i-t[1]<<endl;
        prev=point[i];
        ///cout<<ans<<' '<<rez<<' '<<rez+1<<endl;
    }
    printf("%d\n",ans);
return 0;
}
