#include <iostream>
#include <algorithm>
#include <stack>
using namespace std;
const int MAXN=2e4+10;
struct Rect {
    int x, y;
};
Rect r[MAXN];
stack <int> st;
bool cmp(Rect a, Rect b) {
    if (a.x!=b.x) return a.x<b.x;
    return a.y>b.y;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i=0;i<n;i++) cin >> r[i].x >> r[i].y;
    sort(r,r+n,cmp);
    int ans=0;
    for (int i=0;i<n;i++) {
        if (i!=0 && r[i].x==r[i-1].x) continue;
        while (st.size()!=0 && r[i].y>=r[st.top()].y) st.pop();
        st.push(i);
        ans=max(ans,(int)st.size());
    }
    cout << ans << endl;
    return 0;
}
